Index: pjproject/trunk/pjlib/build/pjlib.dsp
===================================================================
--- pjproject/trunk/pjlib/build/pjlib.dsp	(revision 514)
+++ pjproject/trunk/pjlib/build/pjlib.dsp	(revision 515)
@@ -183,8 +183,4 @@
 # Begin Source File
 
-SOURCE=..\src\pj\equeue_winnt.c
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\pj\errno.c
 # End Source File
@@ -234,11 +230,4 @@
 
 SOURCE=..\src\pj\ioqueue_select.c
-
-!IF  "$(CFG)" == "pjlib - Win32 Release"
-
-!ELSEIF  "$(CFG)" == "pjlib - Win32 Debug"
-
-!ENDIF 
-
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 514)
+++ pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 515)
@@ -320,4 +320,8 @@
 # Begin Source File
 
+SOURCE=..\docs\doxygen.h
+# End Source File
+# Begin Source File
+
 SOURCE=..\include\pjsip.h
 # End Source File
Index: pjproject/trunk/pjsip/docs/doxygen.h
===================================================================
--- pjproject/trunk/pjsip/docs/doxygen.h	(revision 515)
+++ pjproject/trunk/pjsip/docs/doxygen.h	(revision 515)
@@ -0,0 +1,183 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/**
+ * @file doxygen.h
+ * @brief PJSIP Doxygen's mainpage.
+ */
+
+/*////////////////////////////////////////////////////////////////////////// */
+/*
+	INTRODUCTION PAGE
+ */
+
+/**
+
+  @mainpage PJSIP
+
+  \n
+  \n
+  @section intro_sec Introduction
+
+  PJSIP is an Open Source SIP prototol stack, designed to be very small in 
+  footprint, have high performance, and very flexible.
+
+  @subsection hist_sec History
+
+  PJSIP has been actively developed since 2003, but its history goes well
+  beyond that. The author has been developing SIP stack since 1999 during
+  RFC 2543 era, and after several experimentation with different approaches 
+  in the programming (the first stack actually was in C++!), and also with
+  the evolution of the SIP protocol itself, the current/third generation
+  of PJSIP (the 0.2.9 version is the second generation) can be considered 
+  as pretty stable in term of design, and should
+  incorporate all design considerations (and implementation tricks!) that 
+  have been learned over the years. Of course only time will tell if this 
+  statement can still be held true in the future.
+
+
+
+
+  \n
+  \n
+  @section pjsipgetting_started Getting Started
+
+  PJSIP consists of multiple levels of APIs, which each of them layered on
+  top of another. Because of this, new readers may find it a bit difficult
+  to find the place to start.
+
+  In general, I think perhaps I can recommend two approaches on using PJSIP.
+
+
+  \n
+  @subsection getting_started_high Using PJSUA API
+
+  @ref PJSUA_LIB wraps together all SIP components and media into a high level
+  API, suitable for creating typical SIP user agent applications. It 
+  features easy to use API for:
+  - multiple client registration (accounts),
+  - high level SIP and media session (calls),
+  - buddy list, presence and instant messaging,
+  - powerful and very easy to use media manipulation,
+
+  while maintaining some space for customization (custom SIP
+  transport, custom SIP media, etc.) needed by some types of applications.
+  @ref PJSUA_LIB is also aimed to be able to run on devices such as PDA
+  or mobile phones, by carefully allowing application to set the appropriate
+  threading strategy and memory limits (number of calls, media ports, etc.).
+
+  However, @ref PJSUA_LIB may not be the most suitable API for some types
+  of applications, since it is directed towards an easy to use API. For
+  more more advanced use, you may better implement the application by using
+  PJSIP + PJMEDIA directly, as described below.
+
+
+  \n
+  @subsection getting_started_pjsip_pjmedia Using PJSIP and PJMEDIA Directly
+
+  For the ultimate flexibility and power, using PJSIP and PJMEDIA directly
+  is the way to go. The drawback will be, of course, steeper learning curve. 
+
+  However, the following links may provide some useful information:
+  - <A HREF="/docs.htm">PJSIP Developer's Guide</A> PDF
+    document is the ultimate guide to understand PJSIP design concept.
+  - there are some samples in <A HREF="/cgi-bin/viewcvs.cgi/pjproject/trunk/pjsip-apps/src/samples/">
+   <b>pjsip-apps/src/samples</b></A> directory.
+  - @ref PJSUA_LIB source code may also be useful to see how high level
+    API are implemented with PJSIP/PJMEDIA.
+  - and finally, you can always <b>Use the Source</b>!
+
+
+
+  \n
+  \n
+  @section this_doc About This Document
+
+  This document contains the reference information about PJSIP. For
+  more in-depth guide (and information in general), readers are 
+  encouraged to read the <A HREF="/docs.htm">
+  <b>PJSIP Developer's Guide</b></A> PDF document
+  which can be downloaded from http://www.pjsip.org/docs.htm.
+
+  \n
+  @subsection doc_ver Version
+
+  This document corresponds to PJSIP version 0.5.6.
+
+  \n
+  @subsection doc_how_to_read How to Read This Document
+
+  For main navigation, please go to <A HREF="modules.htm"><b>Modules</b></A>
+  link on top of this page.
+
+  This document was generated with <A HREF="http://www.doxygen.org">Doxygen</A>
+  from PJSIP header files.
+
+
+  \n
+  \n
+  @section pjsip_toc Documentation Contents
+
+  Click on <A HREF="modules.htm"><b>Modules</b></A> link on top of this page 
+  to get the detailed table of contents.
+
+  The following are top level sections in the <A HREF="modules.htm">
+  <b>Modules</b></A>, as laid out in the following diagram:
+
+  \image html pjsip-arch.jpg "Static Library Layout"
+
+  Enumerating the static libraries from the bottom:
+
+  - <A HREF="/pjlib/docs/main.htm">PJLIB</A>, is the platform abstraction
+    and framework library, on which all other libraries depend,
+
+  - PJLIB-UTIL, provides auxiliary functions such as text scanning,
+    XML, and STUN,
+
+  - PJMEDIA is the multimedia framework,
+
+  - PJMEDIA-CODEC is the placeholder for media codecs,
+
+  - @ref PJSIP_CORE (<b>PJSIP-CORE</b>) is the very core of the PJSIP library, 
+    and contains the SIP @ref PJSIP_ENDPT, which is the owner/manager for all
+    SIP objects in the application, messaging elements, parsing, transport 
+    management, module management, and stateless operations, and also
+    contains:
+
+  - The @ref PJSIP_TRANSACT module inside <b>PJSIP-CORE</b> provides 
+    stateful operation, and is the base for higher layer features such as 
+    dialogs,
+
+  - The @ref PJSIP_UA module inside <b>PJSIP-CORE</b> manages dialogs, and supports dialog
+    usages,
+
+  - @ref PJSIP_SIMPLE (<b>PJSIP-SIMPLE</b>) provides the base SIP event framework 
+    (which uses the common/base dialog framework) and implements presence 
+    on top of it, and is also used by call transfer functions,
+
+  - @ref PJSIP_HIGH_UA (<b>PJSIP-UA</b>) is the high level abstraction of INVITE sessions
+    (using the common/base dialog framework). This library also provides
+    SIP client registration and call transfer functionality,
+
+  - and finally, @ref PJSUA_LIB (<b>PJSUA-LIB</b>) is the highest level of abstraction, 
+    which wraps together all above functionalities into high level, easy to
+    use API.
+*/
+
+
Index: pjproject/trunk/pjsip/include/pjsip-simple/evsub.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/evsub.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/evsub.h	(revision 515)
@@ -31,4 +31,5 @@
  * @defgroup PJSIP_EVENT_NOT SIP Event Notification (RFC 3265) Module
  * @ingroup PJSIP_SIMPLE
+ * @brief Core Event Subscription framework, used by presence, call transfer, etc.
  * @{
  *
@@ -431,5 +432,5 @@
  *
  * @param sub		The event subscription.
- * @param index		The module id.
+ * @param mod_id	The module id.
  * @param data		Arbitrary data.
  */
Index: pjproject/trunk/pjsip/include/pjsip-simple/evsub_msg.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/evsub_msg.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/evsub_msg.h	(revision 515)
@@ -27,4 +27,5 @@
 
 /**
+ * @defgroup PJSIP_EVENT_HDRS Additional Header Fields
  * @ingroup PJSIP_EVENT_NOT
  * @{
@@ -42,5 +43,7 @@
 typedef struct pjsip_event_hdr
 {
+    /** Standard header fields. */
     PJSIP_DECL_HDR_MEMBER(struct pjsip_event_hdr);
+
     pj_str_t	    event_type;	    /**< Event name. */
     pj_str_t	    id_param;	    /**< Optional event ID parameter. */
@@ -67,9 +70,10 @@
  * Create a new Allow-Events header.
  *
- * @param pool.	    The pool.
+ * @param pool	    The pool.
  *
  * @return	    Allow-Events header.
  */
-PJ_DECL(pjsip_allow_events_hdr*) pjsip_allow_events_hdr_create(pj_pool_t *pool);
+PJ_DECL(pjsip_allow_events_hdr*) 
+pjsip_allow_events_hdr_create(pj_pool_t *pool);
 
 
@@ -79,5 +83,7 @@
 typedef struct pjsip_sub_state_hdr
 {
+    /** Standard header fields. */
     PJSIP_DECL_HDR_MEMBER(struct pjsip_sub_state_hdr);
+
     pj_str_t	    sub_state;		/**< Subscription state. */
     pj_str_t	    reason_param;	/**< Optional termination reason. */
Index: pjproject/trunk/pjsip/include/pjsip-simple/iscomposing.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/iscomposing.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/iscomposing.h	(revision 515)
@@ -27,4 +27,13 @@
 #include <pjlib-util/xml.h>
 
+/**
+ * @defgroup PJSIP_ISCOMPOSING Message Composition Indication (RFC 3994)
+ * @ingroup PJSIP_SIMPLE
+ * @brief Support for Indication of Message Composition (RFC 3994)
+ * @{
+ *
+ * This implements message composition indication, as described in
+ * RFC 3994.
+ */
 
 PJ_BEGIN_DECL
@@ -114,4 +123,8 @@
 
 
+/**
+ * @}
+ */
+
 
 PJ_END_DECL
Index: pjproject/trunk/pjsip/include/pjsip-simple/pidf.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/pidf.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/pidf.h	(revision 515)
@@ -33,4 +33,5 @@
  * @defgroup PJSIP_SIMPLE_PIDF PIDF/Presence Information Data Format (RFC 3863)
  * @ingroup PJSIP_SIMPLE
+ * @brief Support for PIDF/Presence Information Data Format (RFC 3863)
  * @{
  *
Index: pjproject/trunk/pjsip/include/pjsip-simple/presence.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/presence.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/presence.h	(revision 515)
@@ -35,4 +35,5 @@
  * @defgroup PJSIP_SIMPLE_PRES SIP Extension for Presence (RFC 3856)
  * @ingroup PJSIP_SIMPLE
+ * @brief Support for SIP Extension for Presence (RFC 3856)
  * @{
  *
@@ -68,4 +69,7 @@
 
 
+/**
+ * Maximum presence status info.
+ */
 #define PJSIP_PRES_STATUS_MAX_INFO  8
 
Index: pjproject/trunk/pjsip/include/pjsip-simple/xpidf.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-simple/xpidf.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-simple/xpidf.h	(revision 515)
@@ -32,4 +32,5 @@
  * @defgroup PJSIP_SIMPLE_XPIDF XPIDF/Presence Information Data Format
  * @ingroup PJSIP_SIMPLE
+ * @brief Support for XPIDF/Presence Information Data Format
  * @{
  *
Index: pjproject/trunk/pjsip/include/pjsip-ua/sip_inv.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-ua/sip_inv.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-ua/sip_inv.h	(revision 515)
@@ -20,19 +20,71 @@
 #define __SIP_INVITE_SESSION_H__
 
+/**
+ * @file sip_inv.h
+ * @brief INVITE sessions
+ */
+
+
 #include <pjsip/sip_dialog.h>
 #include <pjmedia/sdp_neg.h>
 
 
+/**
+ * @defgroup PJSIP_HIGH_UA User Agent Library
+ * @ingroup PJSIP
+ * @brief Mid-level User Agent Library.
+ *
+ * This is the high level user agent library, which consists of:
+ *  - @ref PJSIP_INV, to encapsulate INVITE sessions and SDP
+ *    negotiation in the session,
+ *  - @ref PJSUA_REGC, high level client registration API, and
+ *  - @ref PJSUA_XFER.
+ *
+ * More detailed information is explained in
+ * <A HREF="/docs.htm">PJSIP Developer's Guide</A>
+ * PDF document, and readers are encouraged to read the document to
+ * get the concept behind dialog, dialog usages, and INVITE sessions.
+ *
+ * The User Agent Library is implemented in <b>pjsip-ua</b> static
+ * library.
+ */
+
+/**
+ * @defgroup PJSIP_INV INVITE Session
+ * @ingroup PJSIP_HIGH_UA
+ * @brief Provides INVITE session management.
+ * @{
+ *
+ * The INVITE session uses the @ref PJSIP_DIALOG framework to manage
+ * the underlying dialog, and is one type of usages that can use
+ * a particular dialog instance (other usages are event subscription,
+ * discussed in @ref PJSIP_EVENT_NOT). The INVITE session manages
+ * the life-time of the session, and also manages the SDP negotiation.
+ *
+ * Application must link with  <b>pjsip-ua</b> static library to use this API.
+ *
+ * More detailed information is explained in
+ * <A HREF="/docs.htm">PJSIP Developer's Guide</A>
+ * PDF document, and readers are encouraged to read the document to
+ * get the concept behind dialog, dialog usages, and INVITE sessions.
+ *
+ * The INVITE session does NOT manage media. If application wants to
+ * use API that encapsulates both signaling and media in a very easy
+ * to use API, it can use @ref PJSUA_LIB for this purpose.
+ */
+
 PJ_BEGIN_DECL
 
 
-typedef enum pjsip_inv_state pjsip_inv_state;
+/**
+ * @see pjsip_inv_session
+ */
 typedef struct pjsip_inv_session pjsip_inv_session;
-typedef struct pjsip_inv_callback pjsip_inv_callback;
+
 
 /**
  * This enumeration describes invite session state.
  */
-enum pjsip_inv_state
+typedef enum pjsip_inv_state
 {
     PJSIP_INV_STATE_NULL,	    /**< Before INVITE is sent or received  */
@@ -43,5 +95,5 @@
     PJSIP_INV_STATE_CONFIRMED,	    /**< After ACK is sent/received.	    */
     PJSIP_INV_STATE_DISCONNECTED,   /**< Session is terminated.		    */
-};
+} pjsip_inv_state;
 
 /**
@@ -50,5 +102,5 @@
  * the invite session.
  */
-struct pjsip_inv_callback
+typedef struct pjsip_inv_callback
 {
     /**
@@ -119,5 +171,7 @@
     void (*on_media_update)(pjsip_inv_session *inv_ses, 
 			    pj_status_t status);
-};
+
+} pjsip_inv_callback;
+
 
 
@@ -188,5 +242,5 @@
  *
  * @param endpt		The endpoint instance.
- * @param callback	Callback structure.
+ * @param cb		Callback structure.
  *
  * @return		PJ_SUCCESS on success, or the appropriate error code.
@@ -311,5 +365,5 @@
  *			received request to see if the request contains 
  *			features that it supports.
- * @param sdp		If application has determined its media capability, 
+ * @param local_sdp	If application has determined its media capability, 
  *			it can specify this capability in this argument. 
  *			If SDP is received in the initial INVITE, the UAS 
@@ -564,4 +618,7 @@
 PJ_END_DECL
 
+/**
+ * @}
+ */
 
 
Index: pjproject/trunk/pjsip/include/pjsip-ua/sip_regc.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-ua/sip_regc.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-ua/sip_regc.h	(revision 515)
@@ -27,15 +27,19 @@
 #include <pjsip/sip_types.h>
 #include <pjsip/sip_auth.h>
-//#include <pjsip/sip_ua.h>
+
+
+/**
+ * @defgroup PJSUA_REGC Client Registration
+ * @ingroup PJSIP_HIGH_UA
+ * @brief High Layer API for performing client registration.
+ * @{
+ *
+ * This provides API for performing client registration. Application must
+ * link with  <b>pjsip-ua</b> static library to use this API.
+
+ */
+
 
 PJ_BEGIN_DECL
-
-/**
- * @defgroup PJSUA_REGC SIP Registration Client
- * @ingroup PJSUA
- * @{
- * \brief
- *   API for performing registration for user agent.
- */
 
 /** Typedef for client registration data. */
@@ -57,13 +61,13 @@
 struct pjsip_regc_cbparam
 {
-    pjsip_regc		*regc;
-    void		*token;
-    int			 code;
-    pj_status_t		 status;
-    pj_str_t		 reason;
-    pjsip_rx_data	*rdata;
-    int			 contact_cnt;
-    int			 expiration;
-    pjsip_contact_hdr	*contact[PJSIP_REGC_MAX_CONTACT];
+    pjsip_regc		*regc;	    /**< Client registration structure.	    */
+    void		*token;	    /**< Arbitrary token.		    */
+    pj_status_t		 status;    /**< Error status.			    */
+    int			 code;	    /**< SIP status code received.	    */
+    pj_str_t		 reason;    /**< SIP reason phrase received.	    */
+    pjsip_rx_data	*rdata;	    /**< The complete received response.    */
+    int			 expiration;/**< Next expiration interval.	    */
+    int			 contact_cnt;/**<Number of contacts in response.    */
+    pjsip_contact_hdr	*contact[PJSIP_REGC_MAX_CONTACT]; /**< Contacts.    */
 };
 
@@ -150,4 +154,5 @@
  *
  * @param regc	    The client registration structure.
+ * @param srv_url   Server URL.
  * @param from_url  The person performing the registration, must be a SIP URL type.
  * @param to_url    The address of record for which the registration is targetd, must
@@ -260,3 +265,7 @@
 PJ_END_DECL
 
+/**
+ * @}
+ */
+
 #endif	/* __PJSIP_REG_H__ */
Index: pjproject/trunk/pjsip/include/pjsip-ua/sip_xfer.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip-ua/sip_xfer.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip-ua/sip_xfer.h	(revision 515)
@@ -29,4 +29,17 @@
 #include <pjsip/sip_msg.h>
 
+/**
+ * @defgroup PJSUA_XFER Call Transfer
+ * @ingroup PJSIP_HIGH_UA
+ * @brief Provides call transfer functionality.
+ * @{
+ *
+ * This implements call transfer functionality to INVITE sessions. The call
+ * transfer functionality uses SIP Event Subscription framework for
+ * managing call transfer status.
+ *
+ * Application must link with <b>pjsip-ua</b> AND <b>pjsip-simple</b> static
+ * libraries to use call transfer functionality.
+ */
 
 
@@ -169,6 +182,9 @@
 
 
+PJ_END_DECL
 
-PJ_END_DECL
+/**
+ * @}
+ */
 
 #endif	/* __PJSIP_XFER_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_auth.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 515)
@@ -30,12 +30,18 @@
 PJ_BEGIN_DECL
 
-
-/**
- * @defgroup PJSIP_AUTH_API Authorization API's
+/**
+ * @addtogroup PJSIP_AUTH Authentication Framework
+ * @ingroup PJSIP_CORE
+ * @brief Client and server side authentication framework.
+ */
+
+/**
+ * @defgroup PJSIP_AUTH_API Authentication API's
  * @ingroup PJSIP_AUTH
+ * @brief Structures and functions to perform authentication.
  * @{
  */
 
-/* Length of digest string. */
+/** Length of digest string. */
 #define PJSIP_MD5STRLEN 32
 
@@ -81,4 +87,5 @@
 typedef struct pjsip_cached_auth_hdr
 {
+    /** Standard list member */
     PJ_DECL_LIST_MEMBER(struct pjsip_cached_auth_hdr);
 
@@ -101,4 +108,5 @@
 typedef struct pjsip_cached_auth
 {
+    /** Standard list member */
     PJ_DECL_LIST_MEMBER(struct pjsip_cached_auth);
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_auth_msg.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_auth_msg.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_auth_msg.h	(revision 515)
@@ -25,19 +25,21 @@
 
 /**
- * @defgroup PJSIP_MSG_AUTHORIZATION Header Field: Authorization and Proxy-Authorization
- * @brief Authorization and Proxy-Authorization header field.
- * @ingroup PJSIP_MSG
+ * @addtogroup PJSIP_MSG_HDR
  * @{
  */
 
 /**
- * Common credential.
+ * Common credential structure represents common credential fields
+ * present in Authorization/Proxy-Authorization header.
  */
 struct pjsip_common_credential
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-};
-
+    pj_str_t	realm;		/**< Credential's realm.    */
+    pjsip_param	other_param;	/**< Other parameters.	    */
+};
+
+/**
+ * @see pjsip_common_credential
+ */
 typedef struct pjsip_common_credential pjsip_common_credential;
 
@@ -49,17 +51,20 @@
 struct pjsip_digest_credential
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-    pj_str_t	username;
-    pj_str_t	nonce;
-    pj_str_t	uri;
-    pj_str_t	response;
-    pj_str_t	algorithm;
-    pj_str_t	cnonce;
-    pj_str_t	opaque;
-    pj_str_t	qop;
-    pj_str_t	nc;
-};
-
+    pj_str_t	realm;		/**< Realm of the credential	*/
+    pjsip_param	other_param;	/**< Other parameters.		*/
+    pj_str_t	username;	/**< Username parameter.	*/
+    pj_str_t	nonce;		/**< Nonce parameter.		*/
+    pj_str_t	uri;		/**< URI parameter.		*/ 
+    pj_str_t	response;	/**< Response digest.		*/
+    pj_str_t	algorithm;	/**< Algorithm.			*/
+    pj_str_t	cnonce;		/**< Cnonce.			*/
+    pj_str_t	opaque;		/**< Opaque value.		*/
+    pj_str_t	qop;		/**< Quality of protection.	*/
+    pj_str_t	nc;		/**< Nonce count.		*/
+};
+
+/**
+ * @see pjsip_digest_credential
+ */
 typedef struct pjsip_digest_credential pjsip_digest_credential;
 
@@ -70,12 +75,15 @@
 struct pjsip_pgp_credential
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-    pj_str_t	version;
-    pj_str_t	signature;
-    pj_str_t	signed_by;
-    pj_str_t	nonce;
-};
-
+    pj_str_t	realm;		/**< Realm.			*/
+    pjsip_param	other_param;	/**< Other parameters.		*/
+    pj_str_t	version;	/**< Version parameter.		*/
+    pj_str_t	signature;	/**< Signature parameter.	*/
+    pj_str_t	signed_by;	/**< Signed by parameter.	*/
+    pj_str_t	nonce;		/**< Nonce parameter.		*/
+};
+
+/**
+ * @see pjsip_pgp_credential
+ */
 typedef struct pjsip_pgp_credential pjsip_pgp_credential;
 
@@ -86,14 +94,22 @@
 struct pjsip_authorization_hdr
 {
+    /** Standard header fiends. */
     PJSIP_DECL_HDR_MEMBER(struct pjsip_authorization_hdr);
+
+    /** Authorization scheme.  */
     pj_str_t scheme;
+
+    /** Type of credentials, depending on the scheme. */
     union
     {
-	pjsip_common_credential common;
-	pjsip_digest_credential digest;
-	pjsip_pgp_credential	pgp;
+	pjsip_common_credential common;	/**< Common fields.	    */
+	pjsip_digest_credential digest;	/**< Digest credentials.    */
+	pjsip_pgp_credential	pgp;	/**< PGP credentials.	    */
     } credential;
 };
 
+/**
+ * @see pjsip_authorization_hdr.
+ */
 typedef struct pjsip_authorization_hdr pjsip_authorization_hdr;
 
@@ -105,34 +121,32 @@
 /**
  * Create SIP Authorization header.
- * @param pool Pool where memory will be allocated from.
- * @return SIP Authorization header.
- */
-PJ_DECL(pjsip_authorization_hdr*) pjsip_authorization_hdr_create(pj_pool_t *pool);
+ * @param pool	    Pool where memory will be allocated from.
+ * @return	    SIP Authorization header.
+ */
+PJ_DECL(pjsip_authorization_hdr*) 
+pjsip_authorization_hdr_create(pj_pool_t *pool);
 
 /**
  * Create SIP Proxy-Authorization header.
- * @param pool Pool where memory will be allocated from.
- * @return SIP Proxy-Authorization header.
- */
-PJ_DECL(pjsip_proxy_authorization_hdr*) pjsip_proxy_authorization_hdr_create(pj_pool_t *pool);
-
-
-/**
- * @}
- */
-
-/**
- * @defgroup PJSIP_WWW_AUTH Header Field: Proxy-Authenticate and WWW-Authenticate
- * @brief Proxy-Authenticate and WWW-Authenticate.
- * @ingroup PJSIP_MSG
- * @{
- */
-
+ * @param pool	    Pool where memory will be allocated from.
+ * @return SIP	    Proxy-Authorization header.
+ */
+PJ_DECL(pjsip_proxy_authorization_hdr*) 
+pjsip_proxy_authorization_hdr_create(pj_pool_t *pool);
+
+
+/**
+ * This structure describes common fields in authentication challenge
+ * headers (WWW-Authenticate and Proxy-Authenticate).
+ */
 struct pjsip_common_challenge
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-};
-
+    pj_str_t	realm;		/**< Realm for the challenge.	*/
+    pjsip_param	other_param;	/**< Other parameters.		*/
+};
+
+/**
+ * @see pjsip_common_challenge
+ */
 typedef struct pjsip_common_challenge pjsip_common_challenge;
 
@@ -143,14 +157,17 @@
 struct pjsip_digest_challenge
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-    pj_str_t	domain;
-    pj_str_t	nonce;
-    pj_str_t	opaque;
-    int		stale;
-    pj_str_t	algorithm;
-    pj_str_t	qop;
-};
-
+    pj_str_t	realm;		/**< Realm for the challenge.	*/
+    pjsip_param	other_param;	/**< Other parameters.		*/
+    pj_str_t	domain;		/**< Domain.			*/
+    pj_str_t	nonce;		/**< Nonce challenge.		*/
+    pj_str_t	opaque;		/**< Opaque value.		*/
+    int		stale;		/**< Stale parameter.		*/
+    pj_str_t	algorithm;	/**< Algorithm parameter.	*/
+    pj_str_t	qop;		/**< Quality of protection.	*/
+};
+
+/**
+ * @see pjsip_digest_challenge
+ */
 typedef struct pjsip_digest_challenge pjsip_digest_challenge;
 
@@ -161,12 +178,15 @@
 struct pjsip_pgp_challenge
 {
-    pj_str_t	realm;
-    pjsip_param	other_param;
-    pj_str_t	version;
-    pj_str_t	micalgorithm;
-    pj_str_t	pubalgorithm;
-    pj_str_t	nonce;
-};
-
+    pj_str_t	realm;		/**< Realm for the challenge.	*/
+    pjsip_param	other_param;	/**< Other parameters.		*/
+    pj_str_t	version;	/**< PGP version.		*/
+    pj_str_t	micalgorithm;	/**< micalgorithm parameter.	*/
+    pj_str_t	pubalgorithm;	/**< pubalgorithm parameter.	*/ 
+    pj_str_t	nonce;		/**< Nonce challenge.		*/
+};
+
+/**
+ * @see pjsip_pgp_challenge
+ */
 typedef struct pjsip_pgp_challenge pjsip_pgp_challenge;
 
@@ -177,15 +197,29 @@
 struct pjsip_www_authenticate_hdr
 {
+    /** Standard header fields. */
     PJSIP_DECL_HDR_MEMBER(struct pjsip_www_authenticate_hdr);
+
+    /** Authentication scheme  */
     pj_str_t	scheme;
+
+    /** This union contains structures that are only relevant
+        depending on the value of the scheme being used.
+     */
     union
     {
-	pjsip_common_challenge	common;
-	pjsip_digest_challenge	digest;
-	pjsip_pgp_challenge	pgp;
+	pjsip_common_challenge	common;	/**< Common fields.	*/
+	pjsip_digest_challenge	digest;	/**< Digest challenge.	*/
+	pjsip_pgp_challenge	pgp;	/**< PGP challenge.	*/
     } challenge;
 };
 
+/**
+ * WWW-Authenticate header.
+ */
 typedef struct pjsip_www_authenticate_hdr pjsip_www_authenticate_hdr;
+
+/**
+ * Proxy-Authenticate header.
+ */
 typedef struct pjsip_www_authenticate_hdr pjsip_proxy_authenticate_hdr;
 
@@ -193,15 +227,19 @@
 /**
  * Create SIP WWW-Authenticate header.
- * @param pool Pool where memory will be allocated from.
- * @return SIP WWW-Authenticate header.
- */
-PJ_DECL(pjsip_www_authenticate_hdr*) pjsip_www_authenticate_hdr_create(pj_pool_t *pool);
+ *
+ * @param pool	    Pool where memory will be allocated from.
+ * @return	    SIP WWW-Authenticate header.
+ */
+PJ_DECL(pjsip_www_authenticate_hdr*) 
+pjsip_www_authenticate_hdr_create(pj_pool_t *pool);
 
 /**
  * Create SIP Proxy-Authenticate header.
- * @param pool Pool where memory will be allocated from.
- * @return SIP Proxy-Authenticate header.
- */
-PJ_DECL(pjsip_proxy_authenticate_hdr*) pjsip_proxy_authenticate_hdr_create(pj_pool_t *pool);
+ *
+ * @param pool	    Pool where memory will be allocated from.
+ * @return	    SIP Proxy-Authenticate header.
+ */
+PJ_DECL(pjsip_proxy_authenticate_hdr*) 
+pjsip_proxy_authenticate_hdr_create(pj_pool_t *pool);
 
 /**
Index: pjproject/trunk/pjsip/include/pjsip/sip_auth_parser.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_auth_parser.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_auth_parser.h	(revision 515)
@@ -30,14 +30,10 @@
 
 /**
- * @defgroup PJSIP_AUTH_PARSER_MODULE Authorization Parser Module
- * @ingroup PJSIP_AUTH
- * @{
- */
-
-/**
  * Initialize and register authorization parser module.
  * This will register parser handler for various Authorization related headers
  * such as Authorization, WWW-Authenticate, Proxy-Authorizization, and 
  * Proxy-Authenticate headers.
+ *
+ * This function is called automatically by the main SIP parser.
  *
  * @return      PJ_SUCCESS or the appropriate status code.
@@ -51,34 +47,23 @@
 
 
-extern const pj_str_t	pjsip_USERNAME_STR,
-			pjsip_REALM_STR,
-			pjsip_NONCE_STR,
-			pjsip_URI_STR,
-			pjsip_RESPONSE_STR,
-			pjsip_ALGORITHM_STR,
-			pjsip_DOMAIN_STR,
-			pjsip_STALE_STR,
-			pjsip_QOP_STR,
-			pjsip_CNONCE_STR,
-			pjsip_OPAQUE_STR,
-			pjsip_NC_STR,
-			pjsip_TRUE_STR,
-			pjsip_FALSE_STR,
-			pjsip_DIGEST_STR,
-			pjsip_PGP_STR,
-			pjsip_MD5_STR,
-			pjsip_AUTH_STR;
-/*
-extern const pj_str_t	pjsip_QUOTED_TRUE_STR,
-			pjsip_QUOTED_FALSE_STR,
-			pjsip_QUOTED_DIGEST_STR,
-			pjsip_QUOTED_PGP_STR,
-			pjsip_QUOTED_MD5_STR,
-			pjsip_QUOTED_AUTH_STR;
-*/
 
-/**
- * @}
- */
+extern const pj_str_t	pjsip_USERNAME_STR, /**< "username" string const.   */
+			pjsip_REALM_STR,    /**< "realm" string const.	    */
+			pjsip_NONCE_STR,    /**< "nonce" string const.	    */
+			pjsip_URI_STR,	    /**< "uri" string const.	    */
+			pjsip_RESPONSE_STR, /**< "response" string const.   */
+			pjsip_ALGORITHM_STR,/**< "algorithm" string const.  */
+			pjsip_DOMAIN_STR,   /**< "domain" string const.	    */
+			pjsip_STALE_STR,    /**< "stale" string const.	    */
+			pjsip_QOP_STR,	    /**< "qop" string const.	    */
+			pjsip_CNONCE_STR,   /**< "cnonce" string const.	    */
+			pjsip_OPAQUE_STR,   /**< "opaque" string const.	    */
+			pjsip_NC_STR,	    /**< "nc" string const.	    */
+			pjsip_TRUE_STR,	    /**< "true" string const.	    */
+			pjsip_FALSE_STR,    /**< "false" string const.	    */
+			pjsip_DIGEST_STR,   /**< "digest" string const.	    */
+			pjsip_PGP_STR,	    /**< "pgp" string const.	    */
+			pjsip_MD5_STR,	    /**< "md5" string const.	    */
+			pjsip_AUTH_STR;	    /**< "auth" string const.	    */
 
 PJ_END_DECL
